<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>Decryptor (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Decryptor (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":6,"i3":10,"i4":10,"i5":10,"i6":9,"i7":10,"i8":10,"i9":10,"i10":6,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":6};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/Decryptor.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/crypt/DataSpaceMapUtils.TransformInfoHeader.html"
               title="class in org.apache.poi.poifs.crypt"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/poifs/crypt/EncryptionHeader.html"
               title="class in org.apache.poi.poifs.crypt"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/crypt/Decryptor.html" target="_top">Frames</a></li>
        <li><a href="Decryptor.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.poifs.crypt</div>
    <h2 title="Class Decryptor" class="title">Class Decryptor</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.poifs.crypt.Decryptor</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd>java.lang.Cloneable</dd>
                </dl>
                <dl>
                    <dt>Direct Known Subclasses:</dt>
                    <dd><a href="../../../../../org/apache/poi/poifs/crypt/agile/AgileDecryptor.html"
                           title="class in org.apache.poi.poifs.crypt.agile">AgileDecryptor</a>, <a
                            href="../../../../../org/apache/poi/poifs/crypt/binaryrc4/BinaryRC4Decryptor.html"
                            title="class in org.apache.poi.poifs.crypt.binaryrc4">BinaryRC4Decryptor</a>, <a
                            href="../../../../../org/apache/poi/poifs/crypt/cryptoapi/CryptoAPIDecryptor.html"
                            title="class in org.apache.poi.poifs.crypt.cryptoapi">CryptoAPIDecryptor</a>, <a
                            href="../../../../../org/apache/poi/poifs/crypt/standard/StandardDecryptor.html"
                            title="class in org.apache.poi.poifs.crypt.standard">StandardDecryptor</a>, <a
                            href="../../../../../org/apache/poi/poifs/crypt/xor/XORDecryptor.html"
                            title="class in org.apache.poi.poifs.crypt.xor">XORDecryptor</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public abstract class <span class="typeNameLabel">Decryptor</span>
extends java.lang.Object
implements java.lang.Cloneable</pre>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- =========== FIELD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.summary">
                        <!--   -->
                    </a>
                        <h3>Field Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Field Summary table, listing fields, and an explanation">
                            <caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Field and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>static java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#DEFAULT_PASSWORD">DEFAULT_PASSWORD</a></span></code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colFirst"><code>static java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#DEFAULT_POIFS_ENTRY">DEFAULT_POIFS_ENTRY</a></span></code>&nbsp;
                                </td>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected <a
                                        href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#encryptionInfo">encryptionInfo</a></span></code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier</th>
                                <th class="colLast" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected </code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#Decryptor--">Decryptor</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a
                                    href="javascript:show(4);">Abstract Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html"
                                        title="class in org.apache.poi.poifs.crypt">Decryptor</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#clone--">clone</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getBlockSizeInBytes--">getBlockSizeInBytes</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>abstract java.io.InputStream</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getDataStream-org.apache.poi.poifs.filesystem.DirectoryNode-">getDataStream</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;dir)</code>
                                    <div class="block">Return a stream with decrypted data.</div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>java.io.InputStream</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getDataStream-java.io.InputStream-int-int-">getDataStream</a></span>(java.io.InputStream&nbsp;stream,
                                    int&nbsp;size,
                                    int&nbsp;initialPos)</code>
                                    <div class="block">Wraps a stream for decryption</div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>java.io.InputStream</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getDataStream-org.apache.poi.poifs.filesystem.POIFSFileSystem-">getDataStream</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;fs)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getEncryptionInfo--">getEncryptionInfo</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html"
                                        title="class in org.apache.poi.poifs.crypt">Decryptor</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getInstance-org.apache.poi.poifs.crypt.EncryptionInfo-">getInstance</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;info)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getIntegrityHmacKey--">getIntegrityHmacKey</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getIntegrityHmacValue--">getIntegrityHmacValue</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getKeySizeInBytes--">getKeySizeInBytes</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>abstract long</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getLength--">getLength</a></span>()</code>
                                    <div class="block">Returns the length of the encrypted data that can be safely read
                                        with
                                        <a href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getDataStream-org.apache.poi.poifs.filesystem.DirectoryNode-"><code>getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)</code></a>.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>javax.crypto.SecretKey</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getSecretKey--">getSecretKey</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getVerifier--">getVerifier</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>javax.crypto.Cipher</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#initCipherForBlock-javax.crypto.Cipher-int-">initCipherForBlock</a></span>(javax.crypto.Cipher&nbsp;cipher,
                                    int&nbsp;block)</code>
                                    <div class="block">Initializes a cipher object for a given block index for
                                        encryption
                                    </div>
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#setChunkSize-int-">setChunkSize</a></span>(int&nbsp;chunkSize)</code>
                                    <div class="block">Sets the chunk size of the data stream.</div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#setEncryptionInfo-org.apache.poi.poifs.crypt.EncryptionInfo-">setEncryptionInfo</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;encryptionInfo)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i16" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#setIntegrityHmacKey-byte:A-">setIntegrityHmacKey</a></span>(byte[]&nbsp;integrityHmacKey)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i17" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#setIntegrityHmacValue-byte:A-">setIntegrityHmacValue</a></span>(byte[]&nbsp;integrityHmacValue)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i18" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#setSecretKey-javax.crypto.SecretKey-">setSecretKey</a></span>(javax.crypto.SecretKey&nbsp;secretKey)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i19" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#setVerifier-byte:A-">setVerifier</a></span>(byte[]&nbsp;verifier)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i20" class="altColor">
                                <td class="colFirst"><code>abstract boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#verifyPassword-java.lang.String-">verifyPassword</a></span>(java.lang.String&nbsp;password)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait,
                                    wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ FIELD DETAIL =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.detail">
                        <!--   -->
                    </a>
                        <h3>Field Detail</h3>
                        <a name="DEFAULT_PASSWORD">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>DEFAULT_PASSWORD</h4>
                                <pre>public static final&nbsp;java.lang.String DEFAULT_PASSWORD</pre>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../constant-values.html#org.apache.poi.poifs.crypt.Decryptor.DEFAULT_PASSWORD">Constant
                                            Field Values</a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="DEFAULT_POIFS_ENTRY">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>DEFAULT_POIFS_ENTRY</h4>
                                <pre>public static final&nbsp;java.lang.String DEFAULT_POIFS_ENTRY</pre>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../constant-values.html#org.apache.poi.poifs.crypt.Decryptor.DEFAULT_POIFS_ENTRY">Constant
                                            Field Values</a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="encryptionInfo">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>encryptionInfo</h4>
                                <pre>protected&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a> encryptionInfo</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="Decryptor--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>Decryptor</h4>
                                <pre>protected&nbsp;Decryptor()</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="getDataStream-org.apache.poi.poifs.filesystem.DirectoryNode-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getDataStream</h4>
                                <pre>public abstract&nbsp;java.io.InputStream&nbsp;getDataStream(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;dir)
                                           throws java.io.IOException,
                                                  java.security.GeneralSecurityException</pre>
                                <div class="block">Return a stream with decrypted data.
                                    <p>
                                        Use <a
                                            href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getLength--"><code>getLength()</code></a>
                                        to get the size of that data that can be safely read from the stream.
                                        Just reading to the end of the input stream is not sufficient because there are
                                        normally padding bytes that must be discarded
                                    </p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>dir</code> - the node to read from</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>decrypted stream</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                    <dd><code>java.security.GeneralSecurityException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getDataStream-java.io.InputStream-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getDataStream</h4>
                                <pre>public&nbsp;java.io.InputStream&nbsp;getDataStream(java.io.InputStream&nbsp;stream,
                                         int&nbsp;size,
                                         int&nbsp;initialPos)
                                  throws java.io.IOException,
                                         java.security.GeneralSecurityException</pre>
                                <div class="block">Wraps a stream for decryption<p>

                                    As we are handling streams and don't know the total length beforehand,
                                    it's the callers duty to care for the length of the entries.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>stream</code> - the stream to be wrapped</dd>
                                    <dd><code>initialPos</code> - initial/current byte position within the stream</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>decrypted stream</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                    <dd><code>java.security.GeneralSecurityException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setChunkSize-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setChunkSize</h4>
                                <pre>public&nbsp;void&nbsp;setChunkSize(int&nbsp;chunkSize)</pre>
                                <div class="block">Sets the chunk size of the data stream.
                                    Needs to be set before the data stream is requested.
                                    When not set, the implementation uses method specific default values
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>chunkSize</code> - the chunk size, i.e. the block size with the same
                                        encryption key
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="initCipherForBlock-javax.crypto.Cipher-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>initCipherForBlock</h4>
                                <pre>public&nbsp;javax.crypto.Cipher&nbsp;initCipherForBlock(javax.crypto.Cipher&nbsp;cipher,
                                              int&nbsp;block)
                                       throws java.security.GeneralSecurityException</pre>
                                <div class="block">Initializes a cipher object for a given block index for encryption
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cipher</code> - may be null, otherwise the given instance is reset to the
                                        new block index
                                    </dd>
                                    <dd><code>block</code> - the block index, e.g. the persist/slide id (hslf)</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>a new cipher object, if cipher was null, otherwise the reinitialized cipher</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.security.GeneralSecurityException</code> - if the cipher can't be
                                        initialized
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="verifyPassword-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>verifyPassword</h4>
                                <pre>public abstract&nbsp;boolean&nbsp;verifyPassword(java.lang.String&nbsp;password)
                                throws java.security.GeneralSecurityException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.security.GeneralSecurityException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getLength--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getLength</h4>
                                <pre>public abstract&nbsp;long&nbsp;getLength()</pre>
                                <div class="block">Returns the length of the encrypted data that can be safely read with
                                    <a href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getDataStream-org.apache.poi.poifs.filesystem.DirectoryNode-"><code>getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)</code></a>.
                                    Just reading to the end of the input stream is not sufficient because there are
                                    normally padding bytes that must be discarded

                                    <p>
                                        The length variable is initialized in <a
                                            href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getDataStream-org.apache.poi.poifs.filesystem.DirectoryNode-"><code>getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)</code></a>,
                                        an attempt to call getLength() prior to getDataStream() will result in
                                        IllegalStateException.
                                    </p></div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>length of the encrypted data</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.IllegalStateException</code> - if <a
                                            href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html#getDataStream-org.apache.poi.poifs.filesystem.DirectoryNode-"><code>getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)</code></a>
                                        was not called
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getInstance-org.apache.poi.poifs.crypt.EncryptionInfo-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getInstance</h4>
                                <pre>public static&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html"
                                        title="class in org.apache.poi.poifs.crypt">Decryptor</a>&nbsp;getInstance(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;info)</pre>
                            </li>
                        </ul>
                        <a name="getDataStream-org.apache.poi.poifs.filesystem.POIFSFileSystem-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getDataStream</h4>
                                <pre>public&nbsp;java.io.InputStream&nbsp;getDataStream(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;fs)
                                  throws java.io.IOException,
                                         java.security.GeneralSecurityException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                    <dd><code>java.security.GeneralSecurityException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getVerifier--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getVerifier</h4>
                                <pre>public&nbsp;byte[]&nbsp;getVerifier()</pre>
                            </li>
                        </ul>
                        <a name="getSecretKey--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getSecretKey</h4>
                                <pre>public&nbsp;javax.crypto.SecretKey&nbsp;getSecretKey()</pre>
                            </li>
                        </ul>
                        <a name="getIntegrityHmacKey--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getIntegrityHmacKey</h4>
                                <pre>public&nbsp;byte[]&nbsp;getIntegrityHmacKey()</pre>
                            </li>
                        </ul>
                        <a name="getIntegrityHmacValue--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getIntegrityHmacValue</h4>
                                <pre>public&nbsp;byte[]&nbsp;getIntegrityHmacValue()</pre>
                            </li>
                        </ul>
                        <a name="setSecretKey-javax.crypto.SecretKey-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setSecretKey</h4>
                                <pre>protected&nbsp;void&nbsp;setSecretKey(javax.crypto.SecretKey&nbsp;secretKey)</pre>
                            </li>
                        </ul>
                        <a name="setVerifier-byte:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setVerifier</h4>
                                <pre>protected&nbsp;void&nbsp;setVerifier(byte[]&nbsp;verifier)</pre>
                            </li>
                        </ul>
                        <a name="setIntegrityHmacKey-byte:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setIntegrityHmacKey</h4>
                                <pre>protected&nbsp;void&nbsp;setIntegrityHmacKey(byte[]&nbsp;integrityHmacKey)</pre>
                            </li>
                        </ul>
                        <a name="setIntegrityHmacValue-byte:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setIntegrityHmacValue</h4>
                                <pre>protected&nbsp;void&nbsp;setIntegrityHmacValue(byte[]&nbsp;integrityHmacValue)</pre>
                            </li>
                        </ul>
                        <a name="getBlockSizeInBytes--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getBlockSizeInBytes</h4>
                                <pre>protected&nbsp;int&nbsp;getBlockSizeInBytes()</pre>
                            </li>
                        </ul>
                        <a name="getKeySizeInBytes--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getKeySizeInBytes</h4>
                                <pre>protected&nbsp;int&nbsp;getKeySizeInBytes()</pre>
                            </li>
                        </ul>
                        <a name="getEncryptionInfo--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getEncryptionInfo</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                                    title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;getEncryptionInfo()</pre>
                            </li>
                        </ul>
                        <a name="setEncryptionInfo-org.apache.poi.poifs.crypt.EncryptionInfo-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setEncryptionInfo</h4>
                                <pre>public&nbsp;void&nbsp;setEncryptionInfo(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                        title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;encryptionInfo)</pre>
                            </li>
                        </ul>
                        <a name="clone--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>clone</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/poifs/crypt/Decryptor.html"
                                                    title="class in org.apache.poi.poifs.crypt">Decryptor</a>&nbsp;clone()
                throws java.lang.CloneNotSupportedException</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
                                    <dd><code>clone</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.CloneNotSupportedException</code></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/Decryptor.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/crypt/DataSpaceMapUtils.TransformInfoHeader.html"
               title="class in org.apache.poi.poifs.crypt"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/poifs/crypt/EncryptionHeader.html"
               title="class in org.apache.poi.poifs.crypt"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/crypt/Decryptor.html" target="_top">Frames</a></li>
        <li><a href="Decryptor.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
